<template>
  <div class="view-dialog">
    <template
      v-if="field.displayType == Constant.PermissionType_HIDDEN || (field.textType && field.textType == 'hidden')"
    >
      <!-- 隐藏 TODO:注意，隐藏时不应该有hidden的field存在，有安全问题，以后要改过来：Jarod -->
      <input type="hidden" v-model="field.value" />
      <div class="mint-cell mint-field" v-if="field.hiddenValue">
        <div class="mint-cell-wrapper" >
          <div class="mint-cell-title">
            <span class="mint-cell-text">{{field.discript?field.discript:field.name}}</span> 
          </div> 
          <div class="mint-cell-value hidden">
            <span>{{field.hiddenValue}}</span>
          </div> 
        </div>
      </div>
    </template>

    <template v-else-if="field.displayType == Constant.PermissionType_MODIFY">
      <!-- 可编辑 -->
      <div v-if="field.mobile">
        <mt-button
          class="view-dialog-btn"
          type="default"
          size="large"
          @click="onBtnClick"
        >
          <img src="../assets/images/nice-cell.png" slot="icon">
          {{field.caption==""?"...":field.caption}}
          <span style="color:red" v-if="field.essential || field.instantValidate || (field.validateLibs && field.validateLibs.indexOf('checkEmpty_system') > 0)">*</span>
        </mt-button>
      </div>
      <comm_dialog
        :modal="false"
        :visible.sync="dialogVisible"
        v-bind="$attrs"
        v-on="$listeners"
        position="bottom"
        style="height: 100%;"
        class="view-model"
        :isView="true"
      >
        <div style="width:100%;height:100%;" @click.stop="showModelDialog">
          <mt-popup v-model="dialogVisible" position="bottom" @click.stop :modal="false" style="height:80%;">
            <view_delegate
              :openParams="params"
              :mutil="field.mutil"
              :selectOne="field.selectOne"
              :clearCheckboxVal="clearCheckboxV"
              :isView = "isView"
              :allow = "field.allow"
              :viewDialogName = "field.caption"
              :selectedDocId = "selectedDocId"
              v-if="dialogVisible"
              ref="viewcomp"
              @updateViewData="checkboxVal"
              @viewSelectedDocIdsLength="viewSelectedDocIdsLength"
            />
            <div class="mint-tabbar is-fixed bottom-btn">
              <div v-show="field.mutil || field.selectOne" class="btn-left">
                <span class="selected">{{$t('select_dept')}}：{{selectedDocIdNum}}</span>
              </div>
              <div >
              </div>
              <mt-button @click="onOk"  type="primary" size="small" style="width: 25%; margin: 8px; 12px 0 0">{{$t('confirm')}}</mt-button>
            </div>
          </mt-popup>
        </div>
      </comm_dialog>
      <!-- <mt-popup v-model="dialogVisible" :modal="false">
        <div style="width:100%;height:100%;" @click.stop="showModelDialog">
          <mt-popup v-model="dialogVisible" position="bottom" @click.stop :modal="false" style="height:80%;">
            <view_delegate
              :openParams="params"
              :mutil="field.mutil"
              :selectOne="field.selectOne"
              :clearCheckboxVal="clearCheckboxV"
              :isView = "isView"
              :allow = "field.allow"
              :viewDialogName = "field.caption"
              v-if="dialogVisible"
              ref="viewcomp"
              @updateViewData="checkboxVal"
            />
            <div class="mint-tabbar is-fixed bottom-btn">
              <div v-show="field.mutil || field.selectOne" class="btn-left">
                <span class="selected">{{$t('select_dept')}}：{{selectedDocIdNum}}</span>
              </div>
              <div >
              </div>
              <mt-button @click="onOk"  type="primary" size="small" style="width: 25%; margin: 8px; 12px 0 0">{{$t('confirm')}}</mt-button>
            </div>
          </mt-popup>
        </div>
      </mt-popup> -->
      <!-- </comm-dialog> -->
    </template>

    <template
      v-else-if="field.displayType == Constant.PermissionType_READONLY || field.displayType == Constant.PermissionType_DISABLED"
    >
      <div v-if="field.mobile">
        <mt-button
          class="view-dialog-btn"
          disabled
          type="default"
          size="large"
          @click="onBtnClick"
        >
          <img src="../assets/images/nice-cell.png" slot="icon">
          {{field.caption==""?"...":field.caption}}
        </mt-button>
      </div>
      
    </template>
  </div>
</template>

<script>
import Constant from "@/Constant.js"
import API from "@/api.js"
import view_delegate from "@/components/view_delegate.vue"
import comm_dialog from "@/components/comm_dialog.vue"
import { Toast } from 'mint-ui'
import controlHidden from "@/assets/js/controlHidden.js"
export default {
  name: "o-view-dialog",
  props: ["id","formdata",''],
  components: {
    view_delegate,
    comm_dialog
  },
  computed: {
    field: function() {
      return this.$parent.findField(this.id);
    },
    params: function() {
      let appId = this.$root.appid;
      return {
        appId: appId,
        actionContent: this.field.dialogView,
        parentId:this.field.docId,
      };
    }
  },
  mounted(){
    this.$nextTick(()=>{
      let field = this.field;
      if(field.isHideType) {
        let id = this.id,
          formShowType = field.formShowType;
        controlHidden({id, field, formShowType})
      }
    })
  },
  data: function() {
    return {
      Constant,
      dialogVisible: false,
      items: {},
      checkboxParams: {},
      newRow: {},
      clearCheckboxV: false,
      selectedData:'',
      allParams:'',
      selectedDocId:[],
      selectedDocIdNum:'',
      isView:true,
      selectAll:false,
      popupVisible:false,
      selectedValArr:[],
      _selects:'',
      viewId:'',
    };
  },
  methods: {
    showModelDialog() {
      this.selectedDocIdNum = '';
      this.popupVisible = false;
      this.dialogVisible = false;

    },
    reciveRocket(){    //未完善，之后可使用此方法代替调用多个$parent的方法
    },
    onChange() {
      this.clearCheckboxV = this.selectAll;
      if(this.selectAll == false) {
        this.selectedData = '';
        this.allParams = '';
        this.selectedDocId = [];
      }
    },
    onBtnClick() {
      this.dialogVisible = true;
      this.popupVisible = true;
      this.isView = true;
      this.selectAll = false;
      // this.selectedDocId = [];
    },
    handleClose() {
      this.dialogVisible = false;
    },
    viewSelectedDocIdsLength(val) {//视图选择框回选的长度
      this.selectedDocIdNum = val
    },
    //选择的值
    checkboxVal(params, arrRow, val) {
      this._selects = params._select;
      this.selectedDocIdNum = val.length;
      let selectedVal = [];
      if(this.field.mapping && this.field.mapping.length > 0) {
        let mapping = this.field.mapping;
        arrRow.forEach( row => {
          for(let item in row.items) {
            for(let i=0; i<mapping.length; i++) {
              if(item == mapping[i].id) {
                let obj = {};
                obj.id = item;
                obj.value = row.items[item].value;
                selectedVal.push(obj);
              }
            }
          }
        })
        let result=[];
        let obj={};
        if(this.field.selectOne || this.field.mutil) {
          for(let i=0; i<selectedVal.length; i++) {
            if(!obj[selectedVal[i].id])
            {
              result.push(selectedVal[i]);
              obj[selectedVal[i].id]=true;
            }else {
              if(result.length > 0 ) {
                for(let j=0; j<result.length; j++) {
                  if(result[j].id == selectedVal[i].id) {
                    result[j].value = result[j].value + ";" + selectedVal[i].value;
                  }
                }
              }
            }
          }
        }else if(!this.field.selectOne && !this.field.mutil){
          for(let i=0; i<selectedVal.length; i++) {
            result.push(selectedVal[i]);
          }
        }
        this.selectedValArr = result;
        this.allParams = params;
        //this.selectedData =  selectedVal.replace(/^(\s|;)+|(\s|;)+$/g, '');
        this.selectedDocId = val;
      }
     
    },
    onOk() {
      //单选
      if(this.selectedDocId.length > 0) {
        let selectedVal = this.selectedData;
        let docId = this.field.docId;
        let inputIdAndName = [] //id+name
        if(this.field.mapping && this.field.mapping.length > 0) {
          let mapping = this.field.mapping;
          for(let i=0; i<mapping.length; i++) {
            for(let j=0; j<this.selectedValArr.length; j++) {
              let obj = {};
              if(mapping[i].id == this.selectedValArr[j].id) {
                obj.id =  docId+"_" + mapping[i].value;
                obj.value = this.selectedValArr[j].value;
                inputIdAndName.push(obj);
              }
            }
          }
        }
        let doc;
        let fieldData;
        //let data='$parent.';
        // for(let i=0; i<5; i++) {  //使用$emit出现问题
        //   data += "$parent.";
        //   let url = 'this.' + data + 'findField'
        //   if(eval(url)) {
        //     console.log("------>",eval(url + '()'))
        //   }
        // }
        if(this.$parent.findField) {
          fieldData = this.$parent.findField();
          // this.$parent.findField(inputIdAndName).value = selectedVal; //10/13之前的写法
          // inputIdAndName.forEach(item => {
          //   this.$parent.findField(item.id).value = item.value;
          // });
          // doc = this.$parent.$parent.$parent.$parent.buildFormData();
          inputIdAndName.forEach(item => {
            let fd = this.$parent.findField(item.id);
            if(fd.formField == "RadioField") {
              for (let i = 0; i < fd.options.length; i++) {
                if(fd.options[i].label == item.value || fd.options[i].option == item.value) {
                  fd.value = fd.options[i].value
                }
              }
            }else {
              fd.value = item.value;
            }
          });
          if(this.$parent.getbuildFormData) { //当只有一个普通表单时
            doc = this.$parent.getbuildFormData();
          }else if(this.$parent.$parent.$parent.$parent.$parent.getbuildFormData){ //当表单时tab标签且只有一层
            doc = this.$parent.$parent.$parent.$parent.$parent.getbuildFormData();
          }
        }else if(this.$parent.$parent.$parent.$parent.$parent.findField) { //当有表单是tab标签时,但好像可以不要了，先留着，等测出bug
          fieldData = this.$parent.$parent.$parent.$parent.$parent.findField.findField();
          inputIdAndName.forEach(item => {
            // this.$parent.$parent.$parent.$parent.$parent.findField(item.id).value = item.value;
            let fd = this.$parent.$parent.$parent.$parent.$parent.findField(item.id);
            if(fd.formField == "RadioField") {
              for (let i = 0; i < fd.options.length; i++) {
                if(fd.options[i].label == item.value) {
                  fd.value = fd.options[i].value
                }
              }
            }else {
              fd.value = item.value;
            }
          });
          doc = this.$parent.$parent.$parent.$parent.$parent.$parent.$parent.$parent.buildFormData();
        }else if (this.$parent.$parent.$parent.$parent.$parent.$parent.$parent.$parent.findField) {
          fieldData = this.$parent.$parent.$parent.$parent.$parent.$parent.$parent.$parent.findField();
          fieldData.fields.forEach(items => {
            if(items.tabs) {
              items.tabs.forEach(item => {
                if(item.fields && item.fields.length > 0) {
                  item.fields.forEach(el => {
                    if(el.id == inputIdAndName) {
                      el.value = selectedVal;
                    }
                  })
                }
              })
            }
          });
          //this.$parent.$parent.$parent.$parent.$parent.$parent.findField(inputIdAndName).value = selectedVal;
          doc = this.$parent.$parent.$parent.$parent.$parent.$parent.$parent.$parent.buildFormData();
        }

        let allData = {
          docId: this.field.docId,
          document:doc,
          fieldId: this.field.divId,
          formId: this.field.formId,
          viewId: this.field.dialogView,
          _selects: this.allParams._select,
        }
        API.runViewDialogConfirmScript(allData, {
          onSucess: response => {
            if (response.data.data && response.data.data != "false") {
              Toast(response.data.data);
            } else if (response.data.data == "false") {
              this.dialogVisible = false;
              Toast(response.data.data);
            } else if (!response.data.data && response.data.errmsg == "ok") {
              API.runViewDialogCallbackScript(allData, {
                onSucess: response => {
                  let fds = fieldData.fields;
                  if(response.data.data.changedField) {
                    let cf = response.data.data.changedField;
                    const loopOpe = fields => {
                      for(let m = 0; m < fields.length; m ++) {
                        for (let j = 0; j < cf.length; j++) {
                          for (let key in cf[j]) {
                            if(key == fields[m].name) {
                              fields[m].value = cf[j][key];
                            }
                          }
                        }
                        if(fields[m].tabs && fields[m].tabs.length > 0) { //选项卡里有fields，fields里又有tabs，tabs里又有fields
                          for(let n = 0; n < fields[m].tabs.length; n ++) {
                            if(fields[m].tabs[n].fields) {
                              loopOpe(fields[m].tabs[n].fields)
                            }
                          }
                        }
                      }
                    }
                    loopOpe(fds);
                  }
                  if (response.data.errmsg == "ok") {
                    if (this.field.refreshOnChanged) {
                      //刷新
                      if(this.$parent.refresh) {
                        this.$parent.refresh(this.field.id);
                      }else if (this.$parent.$parent.$parent.$parent.$parent.$parent.$parent.$parent.refresh) {
                        this.$parent.$parent.$parent.$parent.$parent.$parent.$parent.$parent.refresh(this.field.id)
                      }
                    }
                    this.dialogVisible = false;
                  }
                }
              });
            }
          }
        });
      }else {
        let doc;
        let fieldData;
        if(this.$parent.$parent.$parent.$parent.findField) {
          fieldData = this.$parent.$parent.$parent.$parent.findField();
          doc = this.$parent.$parent.$parent.$parent.buildFormData();
        }else if (this.$parent.$parent.$parent.$parent.$parent.$parent.$parent.$parent.findField) {
          fieldData = this.$parent.$parent.$parent.$parent.$parent.$parent.$parent.$parent.findField();
          doc = this.$parent.$parent.$parent.$parent.$parent.$parent.$parent.$parent.buildFormData();
        }
        let allData = {
            docId: this.field.docId,
            document:doc,
            fieldId: this.field.divId,
            formId: this.field.formId,
            viewId: this.field.dialogView,
            _selects: this._selects,
          }
        API.runViewDialogConfirmScript(allData, {
          onSucess: response => {
            if (response.data.data && response.data.data != "false") {
              Toast(response.data.data);
            } else if (response.data.data == "false") {
              this.dialogVisible = false;
              Toast(response.data.data);
            } else if (!response.data.data && response.data.errmsg == "ok") {
              API.runViewDialogCallbackScript(allData, {
                onSucess: response => {
                  let fds = fieldData.fields;
                  if(response.data.data.changedField) {
                    let cf = response.data.data.changedField;
                    for (let i = 0;  i < fds.length; i++) {
                      for (let j = 0; j < cf.length; j++) {
                        for (let key in cf[j]) {
                          if(key == fds[i].name) {
                            fds[i].value = cf[j][key];
                          }
                        }
                      }
                    }
                  }
                  if (response.data.errmsg == "ok") {
                    if (this.field.refreshOnChanged) {
                      //刷新
                      if(this.$parent.refresh) {
                        this.$parent.refresh(this.field.id);
                      }else if (this.$parent.$parent.$parent.$parent.$parent.$parent.$parent.$parent.refresh) {
                        this.$parent.$parent.$parent.$parent.$parent.$parent.$parent.$parent.refresh(this.field.id)
                      }
                    }
                    this.dialogVisible = false;
                  }
                }
              });
            }
          }
        });
        this.selectedDocIdNum = '';
      }
      
    },
  }
};
</script>